//  support function for MOS
//      1 Apr 2016,  no it is not April Fool
//      all MOS support here is deleted
//			13 Apr 2016  Happy Songkran
//      add semaphore		15 Apr 2016
//		re introduce		15 Feb 2017

#include "s21.h"

#define  PRIVATE   static

/*   data in S2 space

global variables

nump
currentp

process queue  size 16 words

process control block
struct { PC, SP, ... }   size 16 words

stack of each process size 64 words

memory map

0...900    code
1000       int vec
1100       global var
2000       process queue
10000	   heap

*/

extern int M[], R[];

PRIVATE int nump, currentp, Q, qindex, qend;  // address of var in Rz

int myalloc(int k);
void dumpsem(int sem);
void dumpQ(void);

int newsem(void){
	int a;
	a = myalloc(16);
	M[a] = 1;			// init value to 1
	M[a+1] = 0;			// clear semQ
	return a;
}

PRIVATE void blockp(int p){		// terminate p
	int a;
	a = Q + M[qindex];			// effective ads
	M[a] = 1;					// remove from Q
	M[nump]--;
	printf("block %d\n",p);
	interrupt(0);				// task switch
}

PRIVATE void wakeup(int p){		// enqueue process queue
	int a;
	a = Q + M[qend];
	M[a] = p;
	M[a+1] = 0;					// enqueue Q
	M[qend]++;
	M[nump]++;
	printf("wake up %d\n",p);
}

void wait(int sem){
	int v, end;
	M[sem]--;				// value--
	v = M[sem];
	if( v < 0 ){
		end = -v;			// enqueue currentp
		M[sem+end] = M[currentp];
		M[sem+end+1] = 0;
		blockp(M[currentp]);
//		printf("block %d\n",M[currentp]);
	}
	printf("wait sem %d ",sem);
	dumpsem(sem);
	dumpQ();
}

// dequeue semaphore queue
PRIVATE int desemq(int sem){
	int a, i;
	a = M[sem+1];			// get the first in queue
	i = sem+2;
	while(M[i] != 0){
		M[i-1] = M[i];		// move element left
		i++;
	}
	M[i-1] = 0;
	return a;
}

void signal(int sem){
	int p;
	if( M[sem] < 1 ) M[sem]++;
	if( M[sem] <= 0 ){
		p = desemq(sem);
		wakeup(p);
	}
	printf("signal sem %d ",sem);
    dumpsem(sem);
    dumpQ();
}

/*
//  prototype of nextp()
//  return 0 if no process in the queue
int nextp(void){
	int i;
	if(nump == 0) return 0;
	if(M[Q+qindex] == 1){				// move left
		for(i = Q+qindex; i < qend; i++)
			M[i] = M[i+1];
		qend--;
	}else{
		qindex++;
	}
	if( M[Q+qindex] == 0 )
		qindex = 0;
	return M[Q+qindex];
}
*/
void dumpQ(void){
	int a;
	printf("nump %d; Q idx %d: ",M[nump],M[qindex]);
	a = Q;
	while( M[a] != 0 ){
		printf("%d,", M[a]);
		a++;
	}
//	for(i = Q; i<=qend; i++)
//		printf("%d ",M[i]);
	printf("\n");
}

// compact process Q when space > 4
//    scan for 1, mark it e  (the first empty)
//    while not end of queue (0)
//       scan for p, mark it x  (non empty)
//          move p to Q[e]
//          Q[x] = 1
//          e++
//       restart from x+1
//    at end of queue
//    Q[e] = 0
//    scan for currentp
//    update qindex and qend

void compactQ(void){
	int k, a, e;
	k = M[qend] - M[nump];
	if( k < 4 ) return;
	a = M[Q];
	while( M[a] != 0 && M[a] != 1 ) // scan first empty
		a++;
	e = a;					// first empty
	while( M[a] != 0 ){ 	// while not end of Q
		if( M[a] != 1 ){	// scan for p
		   M[e] = M[a];		// move to empty
		   M[a] = 1;		// erase it
		   e++;
		}
		a++;
	}						// at the end of queue
	M[e] = 0;				// mark end of queue
	M[qend] = M[Q] - e;		// update qend
	e = M[qend];
	for(k=0; k < e; k++)
		if( M[Q+k] == M[currentp] ) break;
	M[qindex] = k;			// update qindex
}

void bindsym(void){
	nump = symval("NUMP");
	currentp = symval("CURRENTP");
	Q = symval("Q");
//	qindex = symval("QINDEX");
//	qend = symval("QEND");

	printf("nump %d\n",nump);
	printf("currentp %d\n",currentp);
	printf("Q %d\n",Q);
//	printf("qindex %d\n",qindex);
//	printf("qend %d\n",qend);
}

// -------------- for debugging ----------
/*
// compact process Q when length > 5
void compactQ2(void){
	int k, m, i, j;
	k = qend - Q;
	if( nump == k ) return;
	if( k > 5 ){
		m = 0;
		for(i = 0; i < qindex; i++)		// count 1 in Q
			if(M[Q+i] == 1) m++;
		j = 0;
		for(i = 0; i < k; i++){			// move left
			if(M[Q+i] != 1){
				M[Q+j] = M[Q+i];
				j++;
			}
		}
		M[Q+j] = 0;		// end Q
		qend = Q + j;
		qindex -= m;
	}
}
*/
void enqueueQ(int p){
	int a;
	a = M[Q] + M[qend];
	M[a] = p;
	M[a+1] = 0;
	M[qend]++;
	M[nump]++;
}

void dumpsem(int sem){
	int i;
	printf("sem %d: ",sem);
	for(i = 0; i<16; i++)
		printf("%d ",M[sem+i]);
	printf("\n");
}
/*
int myalloc(int m){
	R[1] = m;
	trap(1,19);
	return R[RETV];
}
*/
void testQ(void){
	M[nump] = 0;
	M[qend] = 0;
	M[qindex] = 0;			// init Q
//	M[currentp] = myalloc(16);
	enqueueQ(M[currentp]);
	enqueueQ(myalloc(16));
	dumpQ();
	printf("qend %d qindex %d\n",M[qend],M[qindex]);
}

void testsem(void){
	int sem1, p;
	testQ();

	sem1 = newsem();
	wait(sem1);
	dumpsem(sem1);
	printf("\n");
//	wait(sem1);
//	currentp = 222;
	wait(sem1);
	dumpsem(sem1);
	printf("\n");
	dumpQ();
	M[qindex] = 1;
	M[currentp] = 10016;
	wait(sem1);
	signal(sem1);
	dumpsem(sem1);
	dumpQ();
	exit(0);
	signal(sem1);
//	signal(sem1);
//	signal(sem1);
	dumpsem(sem1);
	dumpQ();
}

